﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;

namespace XamDockManagerTesting
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ViewModel vm;
        public MainWindow()
        {
            InitializeComponent();
            vm = new ViewModel();
            this.DataContext = vm;
        }

        private void dockManager_ActivePaneChanged(object sender, RoutedPropertyChangedEventArgs<Infragistics.Windows.DockManager.ContentPane> e)
        {

        }

        private void dockManager_ToolWindowLoaded(object sender, Infragistics.Windows.DockManager.Events.PaneToolWindowEventArgs e)
        {


            //var dockManager = this.dockManager;
            //PaneToolWindow window = e.Window;
            //var documentContentHost = dockManager.Content as DocumentContentHost;
            //if (documentContentHost == null)
            //    return;
            //var splitPane = documentContentHost.Panes.First();
            //var tabGroupPane = splitPane.Panes.FirstOrDefault(x => x is TabGroupPane);
            //if (tabGroupPane == null)
            //    return;
            //var contentPane = ((TabGroupPane)tabGroupPane).Items[0] as ContentPane;
            //if (contentPane == null)
            //    return;
            //window.Pane.Panes.First().Style = contentPane.Style;


            //var content = dockManager.Content as DocumentContentHost;
            //if (content == null)
            //    return;
            //var splitPanes = content.Panes;
            //var dockManagerPanes = dockManager.Panes as PanesCollection;
            //var floatingPanes = dockManagerPanes.Dock
            //var pane = e.Window.Pane.Panes.First() as ContentPane;
            //if (pane == null)
            //    return;

        }



        private void dockManager_ToolWindowUnloaded(object sender, Infragistics.Windows.DockManager.Events.PaneToolWindowEventArgs e)
        {

        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            int count = vm.Items.Count + 1;
            if (count % 2 == 0)
                vm.Items.Add(new O2("Tab " + (vm.Items.Count + 1)));
            else
                vm.Items.Add(new O1("Tab " + (vm.Items.Count + 1)));
        }

        private string filePath;

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            FileStream fs= null;
            try
            {
                fs = new FileStream("layout.xml", FileMode.Create, FileAccess.Write);
                this.dockManager.SaveLayout(fs);
                MessageBox.Show("FileLocation: " + fs.Name, "Saved");
                filePath = fs.Name;
            }
            catch (Exception damn)
            {
                MessageBox.Show(damn.ToString(), "Damn ... something went wrong");
            }
            finally
            {
                if(fs!=null)
                    fs.Close();
            }
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            FileStream fs = null;
            try
            {
                if (string.IsNullOrWhiteSpace(filePath))
                {
                    filePath = @"C:\Users\qxg4654\Desktop\XamDockManagerTesting\XamDockManagerTesting\bin\Debug\layout.xml";
                }
                fs = new FileStream(filePath, FileMode.Open, FileAccess.Read);
                this.dockManager.LoadLayout(fs);
            }
            catch (Exception damn)
            {
                MessageBox.Show(damn.ToString(), "Damn ... something went wrong");
            }
            finally
            {
                if (fs != null)
                    fs.Close();
            }
        }

        private void Button_Click_3(object sender, RoutedEventArgs e)
        {
            if (vm.Items.Any())
                vm.Items.Remove(vm.Items.Last());
        }
    }
}
